#include "TextData.h"
#include <fstream>    // CN[hĂB
#include <iostream>
#include <string>
#include <list>
#include <locale>
#include <wchar.h>

/**
* QlURL:http://goodjob.boy.jp/chirashinoura/id/100.html
* split֐
* @param string str 
* @param string delim f~^
* @return list<string> ꂽ
*/
std::list<std::string> split(std::string str, std::string delim)
{
	std::list<std::string> result;
	int cutAt;
	while( (cutAt = str.find_first_of(delim)) != str.npos )
	{
		if(cutAt > 0)
		{
			result.push_back(str.substr(0, cutAt));
		}
		str = str.substr(cutAt + 1);
	}
	if(str.length() > 0)
	{
		result.push_back(str);
	}
	return result;
}

CTextData::CTextData(void)
{
	// ̓eLXgt@C
	ifstream ifs("akiguri_200905112252.txt");

	m_vecCharData.clear();

	std::string buf;

	std::list<std::string> result;
	std::list<std::string>::iterator iter; 

	std::string temp, temp1;

	while(ifs) 
	{
		// eLXgt@C1sǂݍ
		getline(ifs, buf);
		result.clear();
		// ^uŕʂstringlistɊi[
		result = split(buf, "	");

		// KȃtO
		bool silFlag = false;
		bool commentFlag = false;
		int count = 0;
		double start, end;

		// 񐔂JԂ
		for (iter = result.begin(); iter != result.end(); iter)
		{
			// f[^̊i[
			temp = *iter;
			// Ce[^i߂Ă
			iter++;
			// Ԗڂ̕񂩂ŕ
			switch(count)
			{
				// 1Ԗ
			case 0:
				// 1Ԗڂ##̓RgHȂ̂Ŗ
				if (temp.compare("##") == 0)
				{
					//				  printf("comment!\n");
					commentFlag = true;
				}
				// ̂Ƃ͊Jn
				else
				{
					start = atof(temp.c_str());
					// 2ԖڂI
					temp1 = *iter;
					end = atof(temp1.c_str());
					commentFlag = false;
				}
				break;
				// 3Ԗڂ̓^O
			case 2:
				// "SIL"ƐL΂H炵
				if (temp.compare("SIL") == 0)
				{
					silFlag = true;
				}
				else
				{
					silFlag = false;
				}
				break;
				// 6Ԗڂ̎̕
			case 5:
				// RgsȊȌꍇ
				if (!commentFlag)
				{
					// {̏ꍇ̓TCY2ɂȂ
					// woȂǃAt@xbg2ł2ɂȂ̂ŁAƂ肪Kv
					if (temp.size() == 2)
					{
						// Ȃǂ\̂쐬Ċi[
						charData *tempChar = new charData;
						tempChar->startTime = start;
						tempChar->endTime = end;
						tempChar->moji = temp;
						tempChar->silFlag = silFlag;
						tempChar->repeat = (int)((tempChar->endTime - tempChar->startTime)/(double)0.2);
						m_vecCharData.push_back(tempChar);
					}
				}
				break;
			}
			count++;
		}
	}
	createSentenceData();
}

CTextData::~CTextData(void)
{
	for (int i=m_vecCharData.size()-1; i>=0; i--)
	{
		delete m_vecCharData[i];
	}
	m_vecCharData.clear();

	for (int i=textdata.size()-1; i>=0; i--)
	{
		delete textdata[i];
	}
	textdata.clear();
}

void CTextData::createSentenceData()
{
	// 
	textdata.clear();
	std::string sentence;
	sentence.clear();

	// 1sڂ̓̕f[^쐬
	sentenceData *data = new sentenceData;
	data->textdata.clear();

	// f[^當f[^쐬
	if (m_vecCharData.size() > 0)
	{
		data->startTime = m_vecCharData[0]->startTime;
		sentence.append(m_vecCharData[0]->moji.c_str());
	}

	for (int i=1; i<m_vecCharData.size(); i++)
	{
		// "SIL"^Ȍꍇ́Aŕ͂̋؂Ƃ
		if (!(m_vecCharData[i]->silFlag))
		{
			if (sentence.size() == 0)
			{
				data->startTime = m_vecCharData[i]->startTime;
			}
			else
			{
				data->endTime = m_vecCharData[i]->endTime;
			}
			sentence.append(m_vecCharData[i]->moji.c_str());
			// ̎̍ĐԂl"["ǉ
#if 1
			for (int j=0; j<m_vecCharData[i]->repeat; j++)
			{
				sentence.append("[");
			}
#endif
		}
		else
		{
			if (sentence.size() > 0)
			{
				// ̃e|vZ͊ԈႢ
				// beatƕ͈Ⴄ
				int mojinum = sentence.size();
				double time = data->endTime - data->startTime;
				if (mojinum > 0 && time > 0)
				{
					data->tempo = (int)(60.0 / time * (double)mojinum);
				}
				else
				{
					data->tempo = 60;
				}
				data->textdata.append(sentence.c_str());
				textdata.push_back(data);
				sentence.clear();
				data = new sentenceData;
				data->textdata.clear();
			}
		}
	}
}
